using RaftModLoader;
using UltimateWater;
using UnityEngine;
using HMLLibrary;
using HarmonyLib;
using System;
using System.Collections.Generic;
using System.Reflection;
using System.Runtime.CompilerServices;
using FMODUnity;
using Steamworks;
using TMPro;

namespace BioFuelYoinker
 {
    public class BioFuelYoinkerClass : Mod
    {
        public static bool toggleMotorTank = false;
        public static bool toggleFuelTank = true;
        public static bool toggleHoneyTank = false;
        public static bool toggleCompostTank = false;
        public static string pickup = "F";

        public static HashSet<FuelValue_FiltrationType> blackList = new HashSet<FuelValue_FiltrationType> {FuelValue_FiltrationType.FV_WATERTANK, FuelValue_FiltrationType.FV_MOTORTANK, FuelValue_FiltrationType.FV_COMPOSTHONEYTANK, FuelValue_FiltrationType.FV_COMPOSTCOMPOSTTANK, FuelValue_FiltrationType.FV_RECYCLER};
        Harmony harmony;

        public static BioFuelYoinkerClass instance;
        public static string logPrefix => "[" + instance.modlistEntry.jsonmodinfo.name + "]: ";

        public void Start()
        {
            instance = this;
            harmony = new Harmony("net.IAteMinecraft.BioFuelYoinker");
            harmony.PatchAll();
            Debug.Log("Mod BioFuel-Yoinker has been loaded!");
        }

        public void Update()
        {
            if (toggleMotorTank == true && blackList.Contains(FuelValue_FiltrationType.FV_MOTORTANK))
            {
                blackList.Remove(FuelValue_FiltrationType.FV_MOTORTANK);
            } 
            else if (toggleMotorTank == false && !blackList.Contains(FuelValue_FiltrationType.FV_MOTORTANK))
            {
                blackList.Add(FuelValue_FiltrationType.FV_MOTORTANK);
            }

            if (toggleFuelTank == true && blackList.Contains(FuelValue_FiltrationType.FV_FUELTANK))
            {
                blackList.Remove(FuelValue_FiltrationType.FV_FUELTANK);
            } 
            else if (toggleFuelTank == false && !blackList.Contains(FuelValue_FiltrationType.FV_FUELTANK))
            {
                blackList.Add(FuelValue_FiltrationType.FV_FUELTANK);
            }

            if (toggleHoneyTank == true && blackList.Contains(FuelValue_FiltrationType.FV_COMPOSTHONEYTANK))
            {
                blackList.Remove(FuelValue_FiltrationType.FV_COMPOSTHONEYTANK);
            } 
            else if (toggleHoneyTank == false && !blackList.Contains(FuelValue_FiltrationType.FV_COMPOSTHONEYTANK))
            {
                blackList.Add(FuelValue_FiltrationType.FV_COMPOSTHONEYTANK);
            }
            
            if (toggleCompostTank == true && blackList.Contains(FuelValue_FiltrationType.FV_COMPOSTCOMPOSTTANK))
            {
                blackList.Remove(FuelValue_FiltrationType.FV_COMPOSTCOMPOSTTANK);
            } 
            else if (toggleCompostTank == false && !blackList.Contains(FuelValue_FiltrationType.FV_COMPOSTCOMPOSTTANK))
            {
                blackList.Add(FuelValue_FiltrationType.FV_COMPOSTCOMPOSTTANK);
            }
        }
        
        public void OnModUnload()
        {
            harmony.UnpatchAll(harmony.Id);
            Debug.Log("Mod BioFuel-Yoinker has been unloaded!");
        }
        
        static bool ExtraSettingsAPI_Loaded = false;

        public void ExtraSettingsAPI_Load() => ExtraSettingsAPI_SettingsClose();
        public void ExtraSettingsAPI_SettingsClose()
        {
            toggleMotorTank = ExtraSettingsAPI_GetCheckboxState("toggleMotorTank");
            toggleFuelTank = ExtraSettingsAPI_GetCheckboxState("toggleFuelTank");
            toggleHoneyTank = ExtraSettingsAPI_GetCheckboxState("toggleHoneyTank");
            toggleCompostTank = ExtraSettingsAPI_GetCheckboxState("toggleCompostTank");
            pickup = ExtraSettingsAPI_GetKeybindName("Pickup");
        }

        public bool ExtraSettingsAPI_GetCheckboxState(string SettingName) => false;
        public static string ExtraSettingsAPI_GetKeybindName(string SettingName) => "";
        public static KeyCode ExtraSettingsAPI_GetKeybindMain(string SettingName) => KeyCode.None;
        public static KeyCode ExtraSettingsAPI_GetKeybindAlt(string SettingName) => KeyCode.None;

        [ConsoleCommand(name: "toggleMotorTank", docs: "When active, Allows extraction of the default fuel out of the Engine & Battery Charger")]
        public static string ToggleFV_MOTORTANK(string[] args)
        {
            toggleMotorTank = !toggleMotorTank;
            if (toggleMotorTank == true && blackList.Contains(FuelValue_FiltrationType.FV_MOTORTANK))
            {
                blackList.Remove(FuelValue_FiltrationType.FV_MOTORTANK);
            } 
            else if (toggleMotorTank == false && !blackList.Contains(FuelValue_FiltrationType.FV_MOTORTANK))
            {
                blackList.Add(FuelValue_FiltrationType.FV_MOTORTANK);
            }
            return logPrefix + "Is " + (toggleMotorTank ? "now" : "no longer") + " Allowing Extraction";
        }
        [ConsoleCommand(name: "toggleFuelTank", docs: "When active, Allows extraction of the default fuel out of Fuel Tanks ")]
        public static string ToggleFV_FUELTANK(string[] args)
        {
            toggleFuelTank = !toggleFuelTank;
            if (toggleFuelTank == true && blackList.Contains(FuelValue_FiltrationType.FV_FUELTANK))
            {
                blackList.Remove(FuelValue_FiltrationType.FV_FUELTANK);
            } 
            else if (toggleMotorTank == false && !blackList.Contains(FuelValue_FiltrationType.FV_FUELTANK))
            {
                blackList.Add(FuelValue_FiltrationType.FV_FUELTANK);
            }
            return logPrefix + "Is " + (toggleFuelTank ? "now" : "no longer") + " Allowing Extraction";
        }
        [ConsoleCommand(name: "toggleHoneyTank", docs: "When Active, Allows extraction of the default fuel out of the Composter's Honey Tank")]
        public static string ToggleFV_COMPOSTHONEYTANK(string[] args)
        {
            toggleHoneyTank = !toggleHoneyTank;
            if (toggleHoneyTank == true && blackList.Contains(FuelValue_FiltrationType.FV_COMPOSTHONEYTANK))
            {
                blackList.Remove(FuelValue_FiltrationType.FV_COMPOSTHONEYTANK);
            } 
            else if (toggleMotorTank == false && !blackList.Contains(FuelValue_FiltrationType.FV_COMPOSTHONEYTANK))
            {
                blackList.Add(FuelValue_FiltrationType.FV_COMPOSTHONEYTANK);
            }
            return logPrefix + "Is " + (toggleHoneyTank ? "now" : "no longer") + " Allowing Extraction";
        }
        [ConsoleCommand(name: "toggleCompostTank", docs: "When active, Allows extraction of the default fuel out of the Composter's Composting Tank")]
        public static string ToggleFV_COMPOSTCOMPOSTTANK(string[] args)
        {
            toggleCompostTank = !toggleCompostTank;
            if (toggleCompostTank == true && blackList.Contains(FuelValue_FiltrationType.FV_COMPOSTCOMPOSTTANK))
            {
                blackList.Remove(FuelValue_FiltrationType.FV_COMPOSTCOMPOSTTANK);
            } 
            else if (toggleMotorTank == false && !blackList.Contains(FuelValue_FiltrationType.FV_COMPOSTCOMPOSTTANK))
            {
                blackList.Add(FuelValue_FiltrationType.FV_COMPOSTCOMPOSTTANK);
            }
            return logPrefix + "Is " + (toggleCompostTank ? "now" : "no longer") + " Allowing Extraction";
        }
    }

    [HarmonyPatch(typeof(Tank), "OnIsRayed")]
    public class FuelTankHandleExtractionPatch
    {
        static void Postfix(Tank __instance)
        {
            if (!BioFuelYoinkerClass.blackList.Contains(__instance.tankFiltrationType))
            {
                Item_Base item_Base = __instance.defaultFuelToAdd;
                SO_FuelValue filteredFuelValueSoFromItemCheckTakeItem = LiquidFuelManager.GetFilteredFuelValueSoFromItem(item_Base, __instance.tankFiltrationType);
                int fuelValueOfTypeCheckTakeItem = filteredFuelValueSoFromItemCheckTakeItem.fuelValueOfType;
                if (__instance.CurrentTankAmount != 0)
                {
                    LocalizationParameters.itemX = __instance.defaultFuelToAdd.settings_Inventory.DisplayName;
                    RAPI.GetLocalPlayer().canvas.displayTextManager.ShowText(Helper.GetTerm("Game/PickUpX", true),  BioFuelYoinkerClass.ExtraSettingsAPI_GetKeybindMain("Pickup"), 2, 0, false);
                    if (Input.GetKeyDown(BioFuelYoinkerClass.ExtraSettingsAPI_GetKeybindMain("Pickup")) || Input.GetKeyDown(BioFuelYoinkerClass.ExtraSettingsAPI_GetKeybindAlt("Pickup")))
                    { 
                        RAPI.GetLocalPlayer().Animator.SetAnimation(PlayerAnimation.Trigger_GrabItem, true);
                        __instance.SetTankAmount(__instance.CurrentTankAmount - fuelValueOfTypeCheckTakeItem);
                        RAPI.GetLocalPlayer().Inventory.AddItem(__instance.defaultFuelToAdd.UniqueName, 1);
                        if (__instance.CurrentTankAmount == 0)
                        {
                            RAPI.GetLocalPlayer().canvas.displayTextManager.HideDisplayTexts(2);
                        }
                    }
                }
            }
        }
    }
 }